#ifndef SANA2_SANA2SPECIALSTATS_H
#define SANA2_SANA2SPECIALSTATS_H 1
/*
**	$Filename: sana2specialstats.h $
**	$Release: Developer Information$
**	$Revision: 1.2 $
**	$Date: 91/05/08 $
**
**	Defined ids for SANA-II special statistics.
**
**	(C) Copyright 1991 Raymond S. Brand
**		All Rights Reserved
**
**	(C) Copyright 1991 Commodore-Amiga Inc.
**		All Rights Reserved
*/

/*
** Contributions from:
**	Raymond S. Brand,   rsbx@cbmvax.commodore.com,  (215) 431-9100
**	Martin Hunt,      martin@cbmvax.commodore.com,  (215) 431-9100
**	Perry Kivolowitz,           ASDG Incorporated,  (608) 273-6585
*/

#ifndef SANA2_SANA2DEVICE_H
#include <sana2/sana2device.h>
#endif	/* !SANA2_SANA2DEVICE_H */


/*
 * The SANA-II special statistic identifier is an unsigned 32 number.
 * The upper 16 bits identify the type of network wire type to which
 * the statistic applies and the lower 16 bits identify the particular
 * statistic.
 */



/*
 * defined ethernet special statistics
 */

#define S2SS_ETHERNET_BADMULTICAST	((((S2WireType_Ethernet)&0xffff)<<16)|0x0000)
/*
 * This count will record the number of times a received packet tripped
 * the hardware's multicast filtering mechanism but was not actually in
 * the current multicast table.
 */

#define S2SS_ETHERNET_RETRIES		((((S2WireType_Ethernet)&0xffff)<<16)|0x0001)
/*
 * This count records the total number of retries which have resulted
 * from transmissions on this board. 
 */


#endif	/* SANA2_SANA2SPECIALSTATS_H */
